#ifndef WLPDSTM_VERSION_LOCK_H_
#define WLPDSTM_VERSION_LOCK_H_

#define LSB 1u

namespace wlpdstm {

	typedef void *VersionLock;
	//typedef unsigned VersionLock;

	inline bool is_locked(VersionLock lock) {
		return (unsigned)lock & LSB;
	}

	inline unsigned get_value(VersionLock lock) {
		return (unsigned)lock >> 2;
	}

	inline VersionLock get_version_lock(unsigned ts) {
		return (VersionLock)(ts << 2);
	}

	inline VersionLock get_locked(void *thread) {
		return (VersionLock)((unsigned)thread | LSB);
	}

	inline void *get_ptr(VersionLock lock) {
		return (void *)((unsigned)lock & ~LSB);
	}
}

#endif // WLPDSTM_VERSION_LOCK_H_
