#ifndef WLPDSTM_CONSTANTS_H_
#define WLPDSTM_CONSTANTS_H_

namespace wlpdstm {

	// this constant is useful for defining various data structures
	const unsigned MAX_THREADS = 32;

	const unsigned CACHE_LINE_SIZE = 16;

	// the smallest timestamp used
	const unsigned MINIMUM_TS = 0;

	// top level transaction
	const int TX_TOP_LEVEL = 0;
	const int TX_NO_LEVEL = (TX_TOP_LEVEL - 1);

	enum OperationType {
		NO_OP = 0,
		READ_OP = 1,
		WRITE_OP = 2,
		DELETE_OP = 3
	};

	inline char *getOperationName(OperationType optype) {
		char *names[] = {
			"noop",
			"read",
			"write",
			"delete"
		};

		return names[optype];
	}
}

#endif
