/** 
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#include "wlpdstm.h"

void wlpdstm::global_init() {
	//init_tid_generator();

	//global_init_mem();

	CurrentTransaction::GlobalInit();
}

void wlpdstm::thread_init() {
	//init_thread_tid();

	//init_thread_mem();

	CurrentTransaction::ThreadInit();
}

void wlpdstm::start_tx() {
	//mem_tx_start();
	CurrentTransaction::TxStart();
}

void wlpdstm::commit_tx() {
	CurrentTransaction::TxCommit();
	//mem_tx_commit();
}

void wlpdstm::abort_tx() {
	CurrentTransaction::TxAbort();
	//mem_tx_abort();
}

void wlpdstm::restart_tx() {
	CurrentTransaction::TxRestart();
	//mem_tx_abort();
}

void wlpdstm::write_word(void *address, void *value) {
	CurrentTransaction::WriteWord(address, value);
}

void wlpdstm::write_word_local(void *address, void *value) {
	CurrentTransaction::WriteWordLocal(address, value);
}

void *wlpdstm::read_word(void *address) {
	return CurrentTransaction::ReadWord(address);
}

void wlpdstm::tx_free(void *ptr, size_t size) {
	CurrentTransaction::TxFree(ptr, size);
	//CurrentTransaction::LockMemoryBlock(ptr, size);
	//tx_free(ptr);
}

void *wlpdstm::tx_malloc(size_t size) {
	return CurrentTransaction::TxMalloc(size);
}


void wlpdstm::start_tx(Transaction *tx) {
	//mem_tx_start();
	tx->TxStart();
}

void wlpdstm::commit_tx(Transaction *tx) {
	tx->TxCommit();
	//mem_tx_commit();
}

void wlpdstm::restart_tx(Transaction *tx) {
	tx->TxRestart();
	//mem_tx_abort();
}

void wlpdstm::abort_tx(Transaction *tx) {
	tx->TxAbort();
	//mem_tx_abort();
}

void *wlpdstm::read_word(Transaction *tx, void *address) {
	return tx->ReadWord(address);
}

void wlpdstm::write_word(Transaction *tx, void *address, void *value) {
	tx->WriteWord(address, value);
}

void wlpdstm::write_word_local(Transaction *tx, void *address, void *value) {
	tx->WriteWordLocal(address, value);
}

void wlpdstm::tx_free(Transaction *tx, void *ptr, size_t size) {
	tx->TxFree(ptr, size);
	//tx->LockMemoryBlock(ptr, size);
	//tx_free(ptr);
}

void *wlpdstm::tx_malloc(Transaction *tx, size_t size) {
	return tx->TxMalloc(size);
}
